YANG Groupings for HTTP Clients and HTTP Servers
Internet-Draft draft-ietf-netconf-http-client-server-23
Kent Watsen
Watsen Networks
kent+ietf@watsen.net
Operations
NETCONF Working Group
This document presents two YANG modules: the first defines a minimal grouping for configuring an HTTP client, and the second defines a minimal grouping for configuring an HTTP server. It is intended that these groupings will be used to help define the configuration for simple HTTP-based protocols (not for complete web servers or browsers). Support is provided for HTTP/1.1, HTTP/2, and HTTP/3.
Editorial Note (To be removed by RFC Editor)
This draft contains placeholder values that need to be replaced with finalized values at the time of publication. This note summarizes all of the substitutions that are needed. No other RFC Editor instructions are specified elsewhere in this document.
Artwork in this document contains shorthand references to drafts in progress. Please apply the following replacements (note: not all may be present):
- AAAA --> the assigned RFC value for draft-ietf-netconf-crypto-types
- DDDD --> the assigned RFC value for draft-ietf-netconf-tcp-client-server
- FFFF --> the assigned RFC value for draft-ietf-netconf-tls-client-server
- GGGG --> the assigned RFC value for this draft
Artwork in this document contains placeholder values for the date of publication of this draft. Please apply the following replacement:
- 2024-08-15 --> the publication date of this draft
The "Relation to other RFCs" section 1.1 contains the text "one or more YANG modules" and, later, "modules". This text is sourced from a file in a context where it is unknown how many modules a draft defines. The text is not wrong as is, but it may be improved by stating more directly how many modules are defined.
The "Relation to other RFCs" section 1.1 contains a self-reference to this draft, along with a corresponding reference in the Appendix. Please replace the self-reference in this section with "This RFC" (or similar) and remove the self-reference in the "Normative/Informative References" section, whichever it is in.
Tree-diagrams in this draft may use the '\' line-folding mode defined in RFC 8792. However, nicer-to-the-eye is when the '\\' line-folding mode is used. The AD suggested suggested putting a request here for the RFC Editor to help convert "ugly" '\' folded examples to use the '\\' folding mode. "Help convert" may be interpreted as, identify what looks ugly and ask the authors to make the adjustment.
The following Appendix section is to be removed prior to publication:
- Appendix A. Change Log
Introduction
This document presents two YANG 1.1 [RFC7950] modules: the first defines a minimal grouping for configuring an HTTP client, and the second defines a minimal grouping for configuring an HTTP server. It is intended that these groupings will be used to help define the configuration for simple HTTP-based protocols. Support is provided for HTTP/1.1, HTTP/2, and HTTP/3.
Relation to other RFCs
This document presents one or more YANG modules [RFC7950] that are part of a collection of RFCs that work together to, ultimately, support the configuration of both the clients and servers of both the NETCONF [RFC6241] and RESTCONF [RFC8040] protocols.
Primary dependency relationships between the YANG groupings defined in the various RFCs is presented in the below diagram. In some cases, a draft may define secondary groupings that introduce dependencies not illustrated in the diagram. The labels in the diagram are a shorthand name for the defining RFC. The citation reference for shorthand name is provided below the diagram.
Please note that the arrows in the diagram point from referencer to referenced. For example, the "crypto-types" RFC does not have any dependencies, whilst the "keystore" RFC depends on the "crypto-types" RFC.

                               crypto-types
                                 ^      ^
                                /        \
                               /          \
                      truststore         keystore
                       ^     ^             ^  ^
                       |     +---------+   |  |
                       |               |   |  |
                       |      +------------+  |
tcp-client-server      |     /         |      |
   ^    ^        ssh-client-server     |      |
   |    |           ^            tls-client-server
   |    |           |              ^     ^        http-client-server
   |    |           |              |     |                 ^
   |    |           |        +-----+     +---------+       |
   |    |           |        |                     |       |
   |    +-----------|--------|--------------+      |       |
   |                |        |              |      |       |
   +-----------+    |        |              |      |       |
               |    |        |              |      |       |
               |    |        |              |      |       |
            netconf-client-server       restconf-client-server

Label in Diagram to RFC Mapping
Label in Diagram | Originating RFC
crypto-types | [I-D.ietf-netconf-crypto-types]
truststore | [I-D.ietf-netconf-trust-anchors]
keystore | [I-D.ietf-netconf-keystore]
tcp-client-server | [I-D.ietf-netconf-tcp-client-server]
ssh-client-server | [I-D.ietf-netconf-ssh-client-server]
tls-client-server | [I-D.ietf-netconf-tls-client-server]
http-client-server | [I-D.ietf-netconf-http-client-server]
netconf-client-server | [I-D.ietf-netconf-netconf-client-server]
restconf-client-server | [I-D.ietf-netconf-restconf-client-server]
Specification Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Adherence to the NMDA
This document is compliant with the Network Management Datastore Architecture (NMDA) [RFC8342]. For instance, as described in [I-D.ietf-netconf-trust-anchors] and [I-D.ietf-netconf-keystore], trust anchors and keys installed during manufacturing are expected to appear in <operational> (Section 5.3 of [RFC8342]), and <system> [I-D.ietf-netmod-system-config], if implemented.
The "ietf-http-client" Module
This section defines a YANG 1.1 module called "ietf-http-client". A high-level overview of the module is provided in Section 2.1. Examples illustrating the module's use are provided in Section 2.2. The YANG module itself is defined in Section 2.3.
Data Model Overview
This section provides an overview of the "ietf-http-client" module in terms of its features and groupings.
Features
The following diagram lists all the "feature" statements defined in the "ietf-http-client" module:

Features:
  +-- tls-supported
  +-- http-11-supported
  +-- http-2-supported
  +-- http-3-supported
  +-- proxy-connect

The diagram above uses syntax that is similar to but not defined in [RFC8340].
Groupings
The "ietf-http-client" module defines the following "grouping" statements:
- http-client-common-grouping
- http-client-grouping
These groupings are presented in the following subsections.
The "http-client-common-grouping" Grouping
The following tree diagram [RFC8340] illustrates the "http-client-common-grouping" grouping:

  grouping http-client-common-grouping:
    +-- uri                      inet:uri
    +-- protocol-versions?       union
    +-- tls-client-parameters {tls-supported}?
       +---u tlsc:tls-client-grouping

Comments:
- The "http-client-common-grouping" grouping defines a mandatory "uri" leaf. Unlike other "client" groupings in the suite a "client-server" drafts mentioned in Section 1.1, this client grouping encodes configuration for most of the protocol stack. For instance, the "scheme", "userinfo", "host" and "port" parts of the URI syntax encode information that portains to transport layers.
- The "http-client-common-grouping" grouping defines an optional protocol-versions leaf, enabling a client to specify which HTTP protocol versions it is willing to use. When unspecified, the default is for the HTTP client can use any version.
- The "http-client-common-grouping" defines an optional "tls-client-parameters" container, enabling trust anchors and client certificates to be configured, for server that enable the "tls-supported" feature. When unspecified, TLS-based connections are not possible.
- For the referenced grouping statement(s):
  - The "tls-client-grouping" grouping is discussed in Section 3.1.2.1 of [I-D.ietf-netconf-tls-client-server].
The "http-client-grouping" Grouping
The following tree diagram [RFC8340] illustrates the "http-client-grouping" grouping:

  grouping http-client-grouping:
    +---u http-client-common-grouping
    +-- proxy-connect! {proxy-connect}?
       +---u http-client-common-grouping

Comments:
- The "http-client-grouping" defines an optional "proxy-connect" container, enabling connections through proxies, for servers that enable the "proxy-connect" feature.
- For the referenced grouping statement(s):
  - The "http-client-common-grouping" grouping is discussed in Section 2.1.2.1 in this document.
Protocol-accessible Nodes
The "ietf-http-client" module defines only "grouping" statements that are used by other modules to instantiate protocol-accessible nodes. Thus this module, when implemented, does not define any protocol-accessible nodes.
Example Usage
This section presents three examples showing the http-client-grouping populated with some data.
The first example illustrates the case where the HTTP client is configured to connect directly to an HTTP server without TLS.

<!-- The outermost element below doesn't exist in the data model. -->
<!--  It simulates if the "grouping" were a "container" instead.  -->

<http-client xmlns="urn:ietf:params:xml:ns:yang:ietf-http-client">
  <uri>https://user:pass@example.com/foo/bar?query#fragment</uri>
</http-client>

The second example illustrates the case where the HTTP client is configured to connect directly to an HTTP server with TLS.
This example is consistent with examples presented in Section 2.2.1 of [I-D.ietf-netconf-trust-anchors] and Section 2.2.1 of [I-D.ietf-netconf-keystore].

=============== NOTE: '\' line wrapping per RFC 8792 ================

<!-- The outermost element below doesn't exist in the data model. -->
<!--  It simulates if the "grouping" were a "container" instead.  -->

<http-client xmlns="urn:ietf:params:xml:ns:yang:ietf-http-client">
  <uri>https://user:pass@example.com/foo/bar?query#fragment</uri>
  <protocol-versions>http-11 http-2 http-3</protocol-versions>
  <tls-client-parameters>
    <client-identity>
      <certificate>
        <central-keystore-reference>
          <asymmetric-key>rsa-asymmetric-key</asymmetric-key>
          <certificate>ex-rsa-cert</certificate>
        </central-keystore-reference>
      </certificate>
    </client-identity>
    <server-authentication>
      <ca-certs>
        <central-truststore-reference>trusted-server-ca-certs</centr\
al-truststore-reference>
      </ca-certs>
      <ee-certs>
        <central-truststore-reference>trusted-server-ee-certs</centr\
al-truststore-reference>
      </ee-certs>
    </server-authentication>
  </tls-client-parameters>
</http-client>

The following example illustrates the case where the HTTP client is configured to connect through an HTTP proxy.
This example also is consistent with examples presented in Section 2.2.1 of [I-D.ietf-netconf-trust-anchors] and Section 2.2.1 of [I-D.ietf-netconf-keystore].

=============== NOTE: '\' line wrapping per RFC 8792 ================

<!-- The outermost element below doesn't exist in the data model. -->
<!--  It simulates if the "grouping" were a "container" instead.  -->

<http-client xmlns="urn:ietf:params:xml:ns:yang:ietf-http-client">
  <uri>https://user:pass@remote-server-example.com/foo/bar?query#fra\
gment</uri>
  <protocol-versions>http-11 http-2 http-3</protocol-versions>
  <tls-client-parameters>
    <client-identity>
      <certificate>
        <central-keystore-reference>
          <asymmetric-key>rsa-asymmetric-key</asymmetric-key>
          <certificate>ex-rsa-cert</certificate>
        </central-keystore-reference>
      </certificate>
    </client-identity>
    <server-authentication>
      <ca-certs>
        <central-truststore-reference>trusted-server-ca-certs</centr\
al-truststore-reference>
      </ca-certs>
      <ee-certs>
        <central-truststore-reference>trusted-server-ee-certs</centr\
al-truststore-reference>
      </ee-certs>
    </server-authentication>
  </tls-client-parameters>
  <proxy-connect>
    <uri>https://user:pass@proxy-example.com</uri>
    <protocol-versions>http-2</protocol-versions>
  </proxy-connect>
</http-client>

YANG Module
This YANG module has references to [RFC3986], [RFC6991], [RFC8341], [RFC9110], and [I-D.ietf-netconf-tls-client-server].
<CODE BEGINS> file "ietf-http-client@2024-08-15.yang"

module ietf-http-client {
  yang-version 1.1;
  namespace "urn:ietf:params:xml:ns:yang:ietf-http-client";
  prefix httpc;

  import ietf-inet-types {
    prefix inet;
    reference
      "RFC 6991: Common YANG Data Types";
  }

  import ietf-netconf-acm {
    prefix nacm;
    reference
      "RFC 8341: Network Configuration Access Control Model";
  }

  import ietf-tls-client {
    prefix tlsc;
    reference
      "RFC FFFF: YANG Groupings for TLS Clients and TLS Servers";
  }

  organization
    "IETF NETCONF (Network Configuration) Working Group";

  contact
    "WG Web:   https://datatracker.ietf.org/wg/netconf
     WG List:  NETCONF WG list <mailto:netconf@ietf.org>
     Author:   Kent Watsen <mailto:kent+ietf@watsen.net>";

  description
    "This module defines reusable groupings for HTTP clients that
     can be used as a basis for specific HTTP client instances.

     Copyright (c) 2024 IETF Trust and the persons identified
     as authors of the code. All rights reserved.

     Redistribution and use in source and binary forms, with
     or without modification, is permitted pursuant to, and
     subject to the license terms contained in, the Revised
     BSD License set forth in Section 4.c of the IETF Trust's
     Legal Provisions Relating to IETF Documents
     (https://trustee.ietf.org/license-info).

     This version of this YANG module is part of RFC GGGG
     (https://www.rfc-editor.org/info/rfcGGGG); see the RFC
     itself for full legal notices.

     The key words 'MUST', 'MUST NOT', 'REQUIRED', 'SHALL',
     'SHALL NOT', 'SHOULD', 'SHOULD NOT', 'RECOMMENDED',
     'NOT RECOMMENDED', 'MAY', and 'OPTIONAL' in this document
     are to be interpreted as described in BCP 14 (RFC 2119)
     (RFC 8174) when, and only when, they appear in all
     capitals, as shown here.";

  revision 2024-08-15 {
    description
      "Initial version";
    reference
      "RFC GGGG: YANG Groupings for HTTP Clients and HTTP Servers";
  }

  // Features

  feature tls-supported {
    description
      "Indicates that the server supports configuring
       HTTP client certificates.";
    reference
      "RFC 9110: HTTP Semantics";
  }

  feature "http-11-supported" {
    description
      "Indicates that the server supports configuring
       clients to use the HTTP/1.1 protocol.";
    reference
      "RFC 9112: HTTP/1.1";
  }

  feature "http-2-supported" {
    description
      "Indicates that the server supports configuring
       clients to use the HTTP/2 protocol.";
    reference
      "RFC 9113: HTTP/2";
  }

  feature "http-3-supported" {
    if-feature "tls-supported";
    description
      "Indicates that the server supports configuring
       clients to use the HTTP/3 protocol.";
    reference
      "RFC 9114 - HTTP/3";
  }

  feature proxy-connect {
    description
      "Indicates that the server supports configuring HTTP
       clients to connect to a remote HTTP server via a
       proxy, per Section 9.3.6 of RFC 9110.";
    reference
      "RFC 9110: HTTP Semantics";
  }

  // Groupings

  grouping http-client-common-grouping {
    description
      "A grouping for the 'http-client-grouping' and
       its descendant node 'proxy-connect' to use.";
    leaf uri {
      nacm:default-deny-all;
      type inet:uri;
      mandatory true;
      description
        "The URI the client uses.

         As described by RFC 3986, URIs encode:
           - scheme: e.g., https
           - userinfo: e.g., user@pass
           - host: e.g., example.com
           - port: e.g., 443
           - path: e.g., /foo/bar
           - query: e.g., ?query
           - fragment: e.g., #fragment
        ";
        reference
          "RFC 3986  URI Generic Syntax";
    }
    leaf protocol-versions {
      type union {
        type enumeration {
          enum any {
            description
              "Indicates the client is willing to use any version";
          }
        }
        type bits {
          bit "http-11" {
            if-feature "http-11-supported";
            description
              "Indicates the client is willing to use HTTP/1.1.";
          }
          bit "http-2" {
            if-feature "http-2-supported";
            description
              "Indicates the client is willing to use HTTP/2.";
          }
          bit "http-3" {
            if-feature "http-3-supported";
            description
              "Indicates the client is willing to use HTTP/3.";
          }
        }
      }
      default "any";
      description
        "HTTP protocol versions the client supports.";
    }
    container tls-client-parameters {
      if-feature "tls-supported";
      description
        "TLS client parameters.";
      uses tlsc:tls-client-grouping {
        refine server-authentication {
          presence
            "Indicates that TLS-client parameters have been
             configured. This statement is present so the
             mandatory descendant nodes do not imply that
             this node must be configured.";
        }
      }
    }
  }

  grouping http-client-grouping {
    description
      "A reusable grouping for configuring an HTTP client.";
    uses http-client-common-grouping;
    container proxy-connect {
      if-feature proxy-connect;
      presence
        "Indicates that the HTTP-client connects through a proxy.
         This statement is present so the mandatory descendant
         nodes do not imply that this node must be configured.";
      uses http-client-common-grouping;
      description
        "Configures the proxy server the HTTP-client is to
         connect through, per Section 9.3.6 of RFC 9110.";
      reference
        "RFC 9110: HTTP Semantics";
    }
  } // grouping http-client-grouping

}

<CODE ENDS>
The "ietf-http-server" Module
This section defines a YANG 1.1 module called "ietf-http-server". A high-level overview of the module is provided in Section 3.1. Examples illustrating the module's use are provided in Section 3.2. The YANG module itself is defined in Section 3.3.
Data Model Overview
This section provides an overview of the "ietf-http-server" module in terms of its features and groupings.
Features
The following diagram lists all the "feature" statements defined in the "ietf-http-server" module:

Features:
  +-- client-auth-supported
  +-- local-users-supported
  +-- basic-auth
  +-- tcp-supported
  +-- tls-supported
  +-- quic-supported

The diagram above uses syntax that is similar to but not defined in [RFC8340].
Groupings
The "ietf-http-server" module defines the following "grouping" statements:
- http-server-grouping
- http-server-stack-grouping
Each of these groupings are presented in the following subsections.
The "http-server-grouping" Grouping
The following tree diagram [RFC8340] illustrates the "http-server-grouping" grouping:

  grouping http-server-grouping:
    +-- server-name?             string
    +-- client-authentication! {client-auth-supported}?
       +-- users {local-users-supported}?
          +-- user* [user-id]
             +-- user-id?       string
             +-- (auth-type)
                +--:(basic)
                   +-- basic {basic-auth}?
                      +-- username?   string
                      +-- password
                         +-- hashed-password?   ianach:crypt-hash
                         +--ro last-modified?     yang:date-and-time

Comments:
- The "http-server-grouping" defines the configuration for just the "HTTP" part of a protocol stack. It does not, for instance, define any configuration for the "TCP" or "TLS" protocol layers (for that, see Section 3.1.2.2).
- The "server-name" node defines the HTTP server's name, as presented to HTTP clients.
- The "client-authentication" node, which must by enabled by a feature, defines a very simple user-database. Only the "basic" authentication scheme is supported, albeit it must be enabled by a "feature". Other authentication schemes MAY be augmented in.
The "http-server-stack-grouping" Grouping
The following tree diagram [RFC8340] illustrates the "http-server-stack-grouping" grouping:

  grouping http-server-stack-grouping:
    +-- (transport)
       +--:(tcp) {tcp-supported}?
       |  +-- tcp
       |     +-- tcp-server-parameters
       |     |  +---u tcps:tcp-server-grouping
       |     +-- http-server-parameters
       |        +---u http-server-grouping
       +--:(tls) {tls-supported}?
       |  +-- tls
       |     +-- tcp-server-parameters
       |     |  +---u tcps:tcp-server-grouping
       |     +-- tls-server-parameters
       |     |  +---u tlss:tls-server-grouping
       |     +-- http-server-parameters
       |        +---u http-server-grouping
       +--:(quic) {quic-supported}?
          +-- quic
             +-- udp-server-parameters
             |  +---u udps:udp-server-grouping
             +-- tls-server-parameters
             |  +---u tlss:tls-server-grouping
             +-- http-server-parameters
                +---u http-server-grouping

Comments:
- The "http-server-stack-grouping" is a convenience grouping for consuming modules. It defines protocol stacks for HTTP/1.1, HTTP/2, and HTTP/3, with each option enabled by a "feature" statement for application control. Other protocols may be added by future work using the YANG "augment" statement.
- For the referenced grouping statement(s):
  - The "udp-server-grouping" grouping is discussed in Section 3 of [I-D.ietf-netconf-udp-client-server].
  - The "tcp-server-grouping" grouping is discussed in Section 4.1.2.1 of [I-D.ietf-netconf-tcp-client-server].
  - The "tls-server-grouping" grouping is discussed in Section 4.1.2.1 of [I-D.ietf-netconf-tls-client-server].
  - The "http-server-grouping" grouping is discussed in Section 3.1.2.1 in this document.
Protocol-accessible Nodes
The "ietf-http-server" module defines only "grouping" statements that are used by other modules to instantiate protocol-accessible nodes. Thus this module, when implemented, does not define any protocol-accessible nodes.
Example Usage
This section presents an example showing the http-server-grouping populated with some data.

<!-- The outermost element below doesn't exist in the data model. -->
<!--  It simulates if the "grouping" were a "container" instead.  -->

<http-server xmlns="urn:ietf:params:xml:ns:yang:ietf-http-server">
  <server-name>foo.example.com</server-name>
</http-server>

YANG Module
This YANG module has references to [RFC6991], [RFC7317], [RFC7617], [RFC8341], [RFC9110], [I-D.ietf-netconf-tcp-client-server], [I-D.ietf-netconf-tls-client-server], and [I-D.ietf-netconf-udp-client-server].
<CODE BEGINS> file "ietf-http-server@2024-08-15.yang"

module ietf-http-server {
  yang-version 1.1;
  namespace "urn:ietf:params:xml:ns:yang:ietf-http-server";
  prefix https;

  import ietf-yang-types {
    prefix yang;
    reference
      "RFC 6991: Common YANG Data Types";
  }

  import iana-crypt-hash {
    prefix ianach;
    reference
      "RFC 7317: A YANG Data Model for System Management";
  }

  import ietf-netconf-acm {
    prefix nacm;
    reference
      "RFC 8341: Network Configuration Access Control Model";
  }

  import ietf-tcp-server {
    prefix tcps;
    reference
      "RFC DDDD: YANG Groupings for TCP Clients and TCP Servers";
  }

  import ietf-tls-server {
    prefix tlss;
    reference
      "RFC FFFF: YANG Groupings for TLS Clients and TLS Servers";
  }

  import ietf-udp-server {
    prefix udps;
    reference
      "RFC JJJJ: YANG Groupings for UDP Clients and UDP Servers";
  }

  organization
    "IETF NETCONF (Network Configuration) Working Group";

  contact
    "WG Web:   https://datatracker.ietf.org/wg/netconf
     WG List:  NETCONF WG list <mailto:netconf@ietf.org>
     Author:   Kent Watsen <mailto:kent+ietf@watsen.net>";

  description
    "This module defines reusable groupings for HTTP servers that
     can be used as a basis for specific HTTP server instances.

     Copyright (c) 2024 IETF Trust and the persons identified
     as authors of the code. All rights reserved.

     Redistribution and use in source and binary forms, with
     or without modification, is permitted pursuant to, and
     subject to the license terms contained in, the Revised
     BSD License set forth in Section 4.c of the IETF Trust's
     Legal Provisions Relating to IETF Documents
     (https://trustee.ietf.org/license-info).

     This version of this YANG module is part of RFC GGGG
     (https://www.rfc-editor.org/info/rfcGGGG); see the RFC
     itself for full legal notices.

     The key words 'MUST', 'MUST NOT', 'REQUIRED', 'SHALL',
     'SHALL NOT', 'SHOULD', 'SHOULD NOT', 'RECOMMENDED',
     'NOT RECOMMENDED', 'MAY', and 'OPTIONAL' in this document
     are to be interpreted as described in BCP 14 (RFC 2119)
     (RFC 8174) when, and only when, they appear in all
     capitals, as shown here.";

  revision 2024-08-15 {
    description
      "Initial version";
    reference
      "RFC GGGG: YANG Groupings for HTTP Clients and HTTP Servers";
  }

  // Features

  feature client-auth-supported {
    description
      "Indicates that the server supports configuring HTTP
       servers to authenticate HTTP clients.  HTTP-level client
       authentication may not be needed when client authentication
       is expected to occur only at another protocol layer (e.g.,
       TLS).";
  }

  feature local-users-supported {
    if-feature "client-auth-supported";
    description
      "Indicates that the server supports configuring client
       authentication with its own database of local users, as
       opposed to in an application specific location.";
  }

  feature basic-auth {
    if-feature "local-users-supported";
    description
      "Indicates that the server supports configuring 'basic'
       authentication credentials in its local user database.";
    reference
      "RFC 7617: The 'Basic' HTTP Authentication Scheme";
  }

  feature tcp-supported {
    description
      "Indicates that the server supports configuring HTTP
       servers to listen for HTTP 1.1/2.0 connections over TCP.";
    reference
      "RFC 9110: HTTP Semantics";
  }

  feature tls-supported {
    description
      "Indicates that the server supports configuring HTTP
       servers to listen for HTTP 1.1/2.0 connections over TLS.";
    reference
      "RFC 9110: HTTP Semantics";
  }

  feature quic-supported {
    description
      "Indicates that the server supports configuring HTTP
       servers to listen for HTTP/3 connections over QUIC.";
    reference
      "RFC 9114: HTTP/3";
  }

  // Groupings

  grouping http-server-grouping {
    description
      "A reusable grouping for configuring an HTTP server.

       Note that this grouping uses fairly typical descendant
       node names such that a stack of 'uses' statements will
       have name conflicts.  It is intended that the consuming
       data model will resolve the issue (e.g., by wrapping
       the 'uses' statement in a container called
       'http-server-parameters').  This model purposely does
       not do this itself so as to provide maximum flexibility
       to consuming models.";

    leaf server-name {
      nacm:default-deny-write;
      type string;
      description
        "The value of the 'Server' header field.  If not set, then
         underlying software's default value is used.  Set to the
         empty string to disable.";
    }

    container client-authentication {
      if-feature "client-auth-supported";
      nacm:default-deny-write;
      presence
        "Indicates that HTTP based client authentication is
         configured.  This statement is present so the mandatory
         descendant nodes do not imply that this node must be
         configured.";
      description
        "Configures how the HTTP server can authenticate HTTP
         clients.  The HTTP server will request that the HTTP
         client send authentication when needed.";
      container users {
        if-feature "local-users-supported";
        description
          "A list of locally configured users.";
        list user {
          key "user-id";
          description
            "The list of local users configured on this device.";
          leaf user-id {
            type string;
            description
              "The user-id for the authenticating client.";
          }
          choice auth-type {
            mandatory true;
            description
              "The authentication type.";
            case basic {
              container basic {
                if-feature "basic-auth";
                leaf username {
                  type string;
                  description
                    "The username for the authenticating HTTP
                     client.";
                }
                container password {
                  description
                    "The hashed password the HTTP server uses to
                     authenticate this user.  A user is authenticated
                     if the hash of the supplied password matches
                     this value.";
                  leaf hashed-password {
                    type ianach:crypt-hash;
                    description
                      "The password for the authenticating client.";
                  }
                  leaf last-modified {
                    type yang:date-and-time;
                    config false;
                    description
                      "Identifies when the password was last set.";
                  }
                }
                description
                  "The 'basic' HTTP scheme credentials.";
                reference
                  "RFC 7617:
                    The 'Basic' HTTP Authentication Scheme";
              }
            }
          }
        }
      }
    } // container client-authentication
  } // grouping http-server-grouping

  grouping http-server-stack-grouping {
    description
      "A grouping that defines common HTTP-based protocol stacks.";
    choice transport {
      mandatory true;
      description
        "Choice amongst various transports type.";
      case tcp {
        if-feature "tcp-supported";
        container tcp {
          description
            "Container for TCP-based HTTP protocols.";
          container tcp-server-parameters {
            description
              "TCP-level server parameters to
               listen for HTTP connections.";
            uses tcps:tcp-server-grouping {
              refine "local-bind/local-port" {
                default "80";
                description
                  "The HTTP server will attempt to connect
                   to the IANA-assigned well-known port for
                   'http' (80) if no value is specified.";
              }
            }
          }
          container http-server-parameters {
            description
              "HTTP-level server parameters to
               listen for HTTP connections.";
            uses http-server-grouping;
          }
        }
      }
      case tls {
        if-feature "tls-supported";
        container tls {
          description
            "Container for TLS-based HTTP protocols.";
          container tcp-server-parameters {
            description
              "TCP-level server parameters to
               listen for HTTPS connections.";
            uses tcps:tcp-server-grouping {
              refine "local-bind/local-port" {
                default "443";
                description
                  "The HTTP server will attempt to connect
                   to the IANA-assigned well-known port for
                   'https' (443) if no value is specified.";
              }
            }
          }
          container tls-server-parameters {
            description
              "TLS-level server parameters to
               listen for HTTPS connections.";
            uses tlss:tls-server-grouping;
          }
          container http-server-parameters {
            description
              "HTTP-level server parameters to
               listen for HTTPS connections.";
            uses http-server-grouping;
          }
        }
      }
      case quic {
        if-feature "quic-supported";
        container quic {
          description
            "Container for the QUIC-based HTTP/3 protocol.";
          container udp-server-parameters {
            description
              "UDP-level server parameters.";
            uses udps:udp-server-grouping;
          }
          container tls-server-parameters {
            description
              "TLS-level server parameters.";
            uses tlss:tls-server-grouping;
          }
          container http-server-parameters {
            description
              "HTTP-level server parameters.";
            uses http-server-grouping;
          }
        }
      }
    }
  } // http-server-stack-grouping

}

<CODE ENDS>
Security Considerations
The two YANG modules in this document define groupings and will not be deployed as standalone modules. Their security implications may be context dependent based on their use in other modules. The designers of modules which import these grouping must conduct their own analysis of the security considerations.
Considerations for the "ietf-http-client" YANG Module
This section follows the template defined in Section 3.7.1 of [RFC8407].
The "ietf-http-client" YANG module defines "grouping" statements that are designed to be accessed via YANG based management protocols, such as NETCONF [RFC6241] and RESTCONF [RFC8040]. Both of these protocols have mandatory-to-implement secure transport layers (e.g., SSH, TLS) with mutual authentication.
The Network Access Control Model (NACM) [RFC8341] provides the means to restrict access for particular users to a pre-configured subset of all available protocol operations and content.
Please be aware that this YANG module uses groupings from other YANG modules that define nodes that may be considered sensitive or vulnerable in network environments. Please review the Security Considerations for dependent YANG modules for information as to which nodes may be considered sensitive or vulnerable in network environments.
Some of the readable data nodes defined in this YANG module, i.e., excluding imported modules, may be considered sensitive or vulnerable in some network environments. It is thus important to control read access to these data nodes. The following data nodes have particular sensitivity/vulnerability:
- The "uri" node:
  - The "uri" node may encode a cleartext password (basic or digest authentication). For this reason, the NACM extension "default-deny-all" was applied to it.
- The "proxy-connect/uri" node:
  - The "proxy-connect/uri" node may encode a cleartext password (basic or digest authentication). For this reason, the NACM extension "default-deny-all" was applied to it.
The follwing writable data nodes defined in this YANG module, i.e., excluding imported modules, are considered sensitive or vulnerable in network environments:
- The "proxy-connect" node in the "http-client-grouping" grouping may be considered sensitive or vulnerable in some network environments. For this reason, the NACM extension "default-deny-all" has been applied to it. A misconfigured "proxy-connect" node may result in loss of connectivity or, perhaps, unexpectedly elevated authorization.
This module does not define any RPCs, actions, or notifications, and thus the security consideration for such is not provided here.
Considerations for the "ietf-http-server" YANG Module
This section follows the template defined in Section 3.7.1 of [RFC8407].
The "ietf-http-server" YANG module defines "grouping" statements that are designed to be accessed via YANG based management protocols, such as NETCONF [RFC6241] and RESTCONF [RFC8040]. Both of these protocols have mandatory-to-implement secure transport layers (e.g., SSH, TLS) with mutual authentication.
The Network Access Control Model (NACM) [RFC8341] provides the means to restrict access for particular users to a pre-configured subset of all available protocol operations and content.
Please be aware that this YANG module uses groupings from other YANG modules that define nodes that may be considered sensitive or vulnerable in network environments. Please review the Security Considerations for dependent YANG modules for information as to which nodes may be considered sensitive or vulnerable in network environments.
None of the readable data nodes defined in this YANG module, i.e., excluding imported modules, are considered sensitive or vulnerable in network environments. The NACM "default-deny-all" extension has not been set for any data nodes defined in this module.
The follwing writable data nodes defined in this YANG module, i.e., excluding imported modules, are considered sensitive or vulnerable in network environments:
- The "server-name" node in the "http-server-grouping" grouping may be considered sensitive or vulnerable in some network environments. For this reason, the NACM extension "default-deny-write" has been applied to it. A misconfigured "server-name" may mislead clients into not knowing how to interoperate with the server (e.g., "foo v1.0" vs "foo 2.0").
- The "client-authentication" node in the "http-server-grouping" grouping may be considered sensitive or vulnerable in some network environments. For this reason, the NACM extension "default-deny-write" has been applied to it. The feature "tls-supported" is not required, in order to support cases where an external device is used to terminate TLS connections, but such arrangements leave the client- credentials to be unprotected by the transport. Misconfigured "client-authentication" may lead the server to authenticate invalid client credentials.
This module does not define any RPCs, actions, or notifications, and thus the security consideration for such is not provided here.
IANA Considerations
The "IETF XML" Registry
This document registers two URIs in the "ns" subregistry of the IETF XML Registry [RFC3688]. Following the format in [RFC3688], the following registrations are requested:

   URI: urn:ietf:params:xml:ns:yang:ietf-http-client
   Registrant Contact: The IESG
   XML: N/A, the requested URI is an XML namespace.

   URI: urn:ietf:params:xml:ns:yang:ietf-http-server
   Registrant Contact: The IESG
   XML: N/A, the requested URI is an XML namespace.

The "YANG Module Names" Registry
This document registers two YANG modules in the YANG Module Names registry [RFC6020]. Following the format in [RFC6020], the following registrations are requested:

   name:         ietf-http-client
   namespace:    urn:ietf:params:xml:ns:yang:ietf-http-client
   prefix:       httpc
   reference:    RFC GGGG

   name:         ietf-http-server
   namespace:    urn:ietf:params:xml:ns:yang:ietf-http-server
   prefix:       https
   reference:    RFC GGGG

References
Normative References
Informative References
[RFC7950]
[RFC6241]
[RFC8040]
[I-D.ietf-netconf-crypto-types]
[I-D.ietf-netconf-trust-anchors]
[I-D.ietf-netconf-keystore]
[I-D.ietf-netconf-tcp-client-server]
[I-D.ietf-netconf-ssh-client-server]
[I-D.ietf-netconf-tls-client-server]
[I-D.ietf-netconf-http-client-server]
[I-D.ietf-netconf-netconf-client-server]
[I-D.ietf-netconf-restconf-client-server]
[RFC2119]
[RFC8174]
[RFC8342]
[I-D.ietf-netmod-system-config]
[RFC8340]
[RFC3986]
[RFC6991]
[RFC8341]
[RFC9110]
[I-D.ietf-netconf-udp-client-server]
[RFC7317]
[RFC7617]
[RFC8407]
[RFC3688]
[RFC6020]
Change Log
00 to 01
- Modified Abstract and Intro to be more accurate wrt intended applicability.
- In ietf-http-client, removed "protocol-version" and all auth schemes except "basic".
- In ietf-http-client, factored out "client-identity-grouping" for proxy connections.
- In ietf-http-server, removed "choice required-or-optional" and "choice inline-or-external".
- In ietf-http-server, moved the basic auth under a "choice auth-type" limited by new "feature basic-auth".
01 to 02
- Removed the unused "external-client-auth-supported" feature from ietf-http-server.
02 to 03
- Removed "protocol-versions" from ietf-http-server based on HTTP WG feedback.
- Slightly restructured the "proxy-server" definition in ietf-http-client.
- Added http-client example show proxy server use.
- Added a "Note to Reviewers" note to first page.
03 to 04
- Added a parent "container" to "client-identity-grouping" so that it could be better used by the proxy model.
- Added a "choice" to the proxy model enabling selection of proxy types.
- Added 'http-client-stack-grouping' and 'http-server-stack-grouping' convenience groupings.
- Expanded "Data Model Overview section(s) [remove "wall" of tree diagrams].
- Updated the Security Considerations section.
04 to 05
- Fixed titles and a ref in the IANA Considerations section
- Cleaned up examples (e.g., removed FIXMEs)
- Fixed issues found by the SecDir review of the "keystore" draft.
- Updated the "ietf-http-client" module to use the new "password-grouping" grouping from the "crypto-types" module.
05 to 06
- Removed note questioning if okay for app to augment-in a 'path' node when needed, discussed during the 108 session.
- Addressed comments raised by YANG Doctor in the ct/ts/ks drafts.
06 to 07
- Added XML-comment above examples explaining the reason for the unusual top-most element's presence.
- Renamed 'client-auth-config-supported' to 'client-auth-supported' consistent with other drafts.
- Wrapped 'container basic' choice inside a 'case basic' per best practice.
- Aligned modules with `pyang -f` formatting.
- Fixed nits found by YANG Doctor reviews.
07 to 08
- Replaced "base64encodedvalue==" with "BASE64VALUE=" in examples.
- Minor editorial nits
08 to 09
- Fixed up the 'WG Web' and 'WG List' lines in YANG module(s)
- Fixed up copyright (i.e., s/Simplified/Revised/) in YANG module(s)
09 to 10
- NO UPDATE.
10 to 11
- Updated per Shepherd reviews impacting the suite of drafts.
11 to 12
- Updated per Shepherd reviews impacting the suite of drafts.
12 to 13
- Updated per Tom Petch reviews.
- Renamed draft title to limit to HTTP 1.1 and 2.0.
- Added refs to RFCs 7317, 7617, and 9110.
- Added "if-feature local-users-supported" to "feature basic-auth".
13 to 14
- Addresses AD review comments.
- Added note to Editor to fix line foldings.
- Removed "Conventions" section as there are no "BASE64VALUE=" values used in draft.
- Clarified that the modules, when implemented, do not define any protocol-accessible nodes.
- Added Security Considerations text to also look a SC-section from imported modules.
- Removed "A wrapper around the foobar parameters to avoid name collisions" text.
- Removed "public-key-format" and "public-key" nodes from examples.
14 to 15
- Addresses AD review by Rob Wilton.
15 to 16
- Addresses 1st-round of IESG reviews.
16 to 18
- Addresses issues found in OpsDir review of the ssh-client-server draft.
- s/defines/presents/ in a few places.
- Add refs to where the 'operational' and 'system' datastores are defined.
- Renamed Security Considerations section s/Template for/Considerations for/.
- Updated "http-client-stack-grouping" and "http-server-stack-grouping" for HTTP/3.
18 to 19
- Address IESG review comments.
19 to 20
- Updated to reflect comments from Paul Wouters.
Acknowledgements
The authors would like to thank the following for lively discussions on list and in the halls (ordered by first name): Ben Schwartz, Éric Vyncke, Mark Nottingham, Mahesh Jethanandani, Murray Kucherawy, Orie Steele, Rob Wilton, Roman Danyliw, Shivan Sahib, and Willy Tarreau.